<template>
    <section >  
        <div class="title">
            Search Blogs
        </div>
        <div class="columns is-moblie">
            <div class="column">
                <b-field label="Tiêu Đề">
                    <b-input placeholder="Search..."
                    type="search"
                    icon="magnify"
                     v-model="search">
                    </b-input>
                    <b-button @click="btnSearch(search)" type="is-success">Search</b-button>
                </b-field>
                <section>
                    <div class="title">List Blogs</div>
                    <b-table    :data="items" 
                                focusable 
                                :selected.sync="selected"
                                :paginated="isPaginated"
                                :per-page="perPage"
                                :current-page.sync="currentPage"
                                aria-next-label="Next page"
                                aria-previous-label="Previous page"
                                aria-page-label="Page"
                                aria-current-label="Current page"
                                :pagination-simple="isPaginationSimple"
                                :pagination-position="paginationPosition"
                                :default-sort-direction="defaultSortDirection">
                        <template slot-scope="props">
                            <b-table-column field="id" label="ID">
                                {{props.row.id}}
                            </b-table-column >
                            <b-table-column field="title" label="Tin">
                                {{props.row.title}}
                            </b-table-column >
                            <b-table-column field="category" label="Loại">
                                {{getCategory(props.row.category)}}
                            </b-table-column >
                            <b-table-column field="public" label="Trạng Thái">
                                {{props.row.public?"Yes":"No"}}
                            </b-table-column >
                            <b-table-column field="position" label="Vị Trí">
                                {{getPosition(props.row.position)}}
                            </b-table-column >
                            <b-table-column field="date_pubblic" label="Ngày pubblic">
                                {{props.row.data_pubblic}}
                            </b-table-column >
                            <b-table-column field="id" label="Edit">
                                <a @click="urltocken(props.row.id)" href="/edit" class="link is-info"><b-button class="button is-success" type="submit" icon-right="pencil" @click="urltocken(props.row.id)" >Edit</b-button></a>
                            </b-table-column >
                            <b-table-column field="id" label="Delet">
                                <b-button class="button is-danger" type="button" @click="deleteRow(props.row.id)" icon-right="delete">Delete</b-button>
                            </b-table-column >
                        </template>
                    </b-table>
                </section>
            </div>
        </div>
    </section>
</template>

<script>
import callApi from './../middleware/apiCaller.js'
    export default {
        data(){
            return{
                id:'',
                items:[],
                search:'',
                dataCategory:'',
                dataPosition:'',
                selected:true,
                currentPage: 1,
                perPage: 10,
                isPaginated: true,
                isPaginationSimple: false,
                paginationPosition: 'bottom',
                defaultSortDirection: 'asc',
            }
        },
        mounted(){

            callApi('blogs','GET',null).then(res =>{
                this.items=res.data
            })

             callApi('category', 'GET', null).then(res =>{
                this.dataCategory=res.data
            })

            callApi('position', 'GET',null).then(res =>{
                this.dataPosition=res.data
            })
        },

        updated(){
            if(this.search===""){
                callApi('blogs','GET',null).then(res =>{
                this.items=res.data
                console.log('loadData')
            })
            }
        },

        methods:{
            btnSearch(key){
                let keyword = key.toLowerCase();
                var arr = this.items.filter((item,index) =>{
                    item.title= item.title.toLowerCase()
                    return item.title.indexOf(keyword) > -1;
                })
                this.items= arr;
                console.log(this.items)
                
            },
            getCategory(id){
                for( let i=0 ; i < this.dataCategory.length; i++){
                    if(this.dataCategory[i].id===id){
                        return this.dataCategory[i].namecategory
                        }
                    }
            },

            getPosition(position){
                for(let i = 0 ; i < position.length; i++){
                    for(let j = 0; j<this.dataPosition.length; j++){
                        if(this.dataPosition[j].id===position[i]){
                        return this.dataPosition[j].position
                        }
                    }
                }
            },

            deleteRow(key){
                this.$dialog.confirm({
                title: 'Deleting Intance',
                message: 'Are you sure you want to <b>delete</b> your Instance? This action cannot be undone.',
                confirmText: 'Delete Intance',
                type: 'is-danger',
                hasIcon: true,
                onConfirm: () => {
                    callApi('blogs/'+key,'DELETE').then(res =>{
                        this.items.slice(key,1)
                        this.$toast.open('Instance deleted!')
                        })
                    }
                })
            },

            urltocken(id){
                let parsed = JSON.stringify(id);
                localStorage.setItem('id', parsed);
            }
        },
        watch:{
            items(newItems){
            this.items=newItems
            },

            id(newId){
            localStorage.id=newId;
            },
            search(newSearch){
                this.search=newSearch
            }
        }
    }
</script>

<style lang="css" scoped>
.button a{
  display: block;
}
</style>